#include "fxlib.h"
#include "MonochromeLib.h"
#include "stdlib.h"

#define __KEYBIOS_H__
#include "fxlib.h"
 
 
#define KEY_CHAR_0 OS2(0x30,71)
#define KEY_CHAR_1 OS2(0x31,72)
#define KEY_CHAR_2 OS2(0x32,62)
#define KEY_CHAR_3 OS2(0x33,52)
#define KEY_CHAR_4 OS2(0x34,73)
#define KEY_CHAR_5 OS2(0x35,63)
#define KEY_CHAR_6 OS2(0x36,53)
#define KEY_CHAR_7 OS2(0x37,74)
#define KEY_CHAR_8 OS2(0x38,64)
#define KEY_CHAR_9 OS2(0x39,54)
#define KEY_CHAR_DP OS2(0x2e,61)
#define KEY_CHAR_EXP OS2(0x0f,51)
#define KEY_CHAR_PMINUS OS2(0x87,41)
#define KEY_CHAR_PLUS OS2(0x89,42)
#define KEY_CHAR_MINUS OS2(0x99,32)
#define KEY_CHAR_MULT OS2(0xa9,43)
#define KEY_CHAR_DIV OS2(0xb9,33)
#define KEY_CHAR_FRAC OS2(0xbb,75)
#define KEY_CHAR_LPAR OS2(0x28,55)
#define KEY_CHAR_RPAR OS2(0x29,45)
#define KEY_CHAR_COMMA OS2(0x2c,35)
#define KEY_CHAR_STORE OS2(0x0e,25)
#define KEY_CHAR_LOG OS2(0x95,66)
#define KEY_CHAR_LN OS2(0x85,56)
#define KEY_CHAR_SIN OS2(0x81,46)
#define KEY_CHAR_COS OS2(0x82,36)
#define KEY_CHAR_TAN OS2(0x83,26)
#define KEY_CHAR_SQUARE OS2(0x8b,67)
#define KEY_CHAR_POW OS2(0xa8,57)
#define KEY_CTRL_EXE OS2(30004,31)
#define KEY_CTRL_DEL OS2(30025,44)
#define KEY_CTRL_AC OS2(30015,32)
#define KEY_CTRL_FD OS2(30046,65)
#define KEY_CTRL_EXIT OS2(30002,47)
#define KEY_CTRL_SHIFT OS2(30006,78)
#define KEY_CTRL_ALPHA OS2(30007,77)
#define KEY_CTRL_OPTN OS2(30008,68)
#define KEY_CTRL_VARS OS2(30016,58)
#define KEY_CTRL_UP OS2(30018,28)
#define KEY_CTRL_DOWN OS2(30023,37)
#define KEY_CTRL_LEFT OS2(30020,38)
#define KEY_CTRL_RIGHT OS2(30021,27)
#define KEY_CTRL_F1 OS2(30009,79)
#define KEY_CTRL_F2 OS2(30010,69)
#define KEY_CTRL_F3 OS2(30011,59)
#define KEY_CTRL_F4 OS2(30012,49)
#define KEY_CTRL_F5 OS2(30013,39)
#define KEY_CTRL_F6 OS2(30014,29)
#define KEY_CTRL_MENU OS2(30003,48)
 
#ifndef isOS2// This is new
 
typedef int(*sc_i2cp2sip)(char*, char*, short int*, short int*);
const unsigned int sc0015[] = { 0xD201D002, 0x422B0009, 0x80010070, 0x0015 };
#define GlibGetOSVersionInfo (*(sc_i2cp2sip)sc0015)
 
int OSVersionAsInt(void)
{
unsigned char mainversion;
unsigned char minorversion;
unsigned short release;
unsigned short build;
GlibGetOSVersionInfo( &mainversion, &minorversion, &release, &build );
return ( ( mainversion << 24 ) & 0xFF000000 ) | ( ( minorversion << 16 ) & 0x00FF0000 ) | ( release & 0x0000FFFF );
}
 
#define isOS2 (OSVersionAsInt() >= 0x02020000)
#define OS2(x,y) ((OSVersionAsInt() >= 0x02020000)?y:x)
 
#endif
 
const unsigned short* keyboardregister = (unsigned short*)0xA44B0000;
 
unsigned short key[8] = {0};
 
int KeyDown(int keycode)
{
if(isOS2)
{
int row, col, word, bit;
row = keycode%10;
col = keycode/10-1;
word = row>>1;
bit = col + 8*(row&1);
memcpy(key, keyboardregister, sizeof(unsigned short) << 3);
 
Sleep(1); //slow down, this function is faster than IsKeyDown() :-P
 
return (0 != (key[word] & 1<<bit));
}
else
{
return IsKeyDown(keycode);
}
}
 
#define IsKeyDown(x) KeyDown(x)
#define IsKeyUp(x) !KeyDown(x)


char espace[5][2][10];

// merci a Eiyeron pour les deux fonctions
// intToStr et printn

// et merci a pierrotll pour la librairie MonochromeLib

unsigned char* intToStr(unsigned char* c, int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        if(n<0)
        {
            c[0] = '-';
            n = abs(n);
            l++;
        }
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
	return c;
}
// transforme un nombre entier (int) en chaine de caractres

void printn(unsigned char x, unsigned char y, int n, char mode)
{
	unsigned char c[12];

	intToStr(c, n);
	locate(x,y);
	if(mode)
		PrintRev(c);
	else
		Print(c);
}
// affiche un entier aux coordonnes passes en argument

void represent(char objnoirx[],char objnoiry[],char objblancx[],char objblancy[],int noirlongueur,int blanclongueur,int x,int y,double z){
	int i;
	x -= 64; // necessaire car le calcul se servira d'un coefficient de reduction
	y -= 32;
	z = z/5 +1; // coefficient de reduction selon profondeur calcule
	for( i = 0; i < blanclongueur; i++  ){  // parcours de chaque point du sprite de l'objet
		ML_pixel( (x+objblancx[i])/z +64, (y+objblancy[i])/z +32,ML_WHITE); // transformation de l'objet en coordonnes sur l'ecran
	}
	for( i = 0; i < noirlongueur; i++  ){
		ML_pixel( (x+objnoirx[i])/z +64, (y+objnoiry[i])/z +32,ML_BLACK); // idem en positif
	}
}
// cette fonction va afficher un objet en perpective aux coordonnes 3 dimensions
// passes en argument
// il dessinera d'abord les pixels a effacer pour supprimmer la transparence, puis dessine le vaisseau en noir

void intro(){
	int i;
	const unsigned char louloux[] = {
		0,1,224,3,252,15,7,158,0,63,192,240,127,193,240,0,
		0,3,224,7,254,15,7,190,0,127,224,240,127,227,224,0,
		0,3,192,15,255,30,15,188,0,255,241,224,243,231,192,0,
		0,3,192,31,31,30,15,60,1,240,241,224,241,255,128,0,
		0,7,128,62,15,30,15,120,3,224,113,224,241,255,0,0,
		0,7,128,60,15,60,31,120,3,192,115,193,225,254,0,0,
		0,7,128,120,15,60,30,120,7,128,115,193,224,252,0,0,
		0,15,0,120,15,60,30,240,7,128,243,193,227,252,0,0,
		0,15,0,120,30,120,60,240,7,129,231,131,199,254,0,0,
		0,15,254,124,60,124,124,255,231,195,199,199,207,254,0,0,
		0,31,254,127,248,127,249,255,231,255,135,255,159,30,0,0,
		0,31,252,63,240,63,241,255,195,255,3,255,62,31,0,0,
		0,31,248,31,192,31,193,255,129,252,1,252,124,31,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,96,0,0,0,0,0,0,0,0,0,0,0,0,0,1,255,240,0,0,0,0,0,0,0,0,0,0,0,0,
		0,2,85,8,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,8,0,0,0,0,0,0,0,0,0,0,0,0,
		0,1,255,232,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,7,128,30,0,0,30,0,0,0,0,0,0,
		0,0,0,0,31,224,127,128,240,127,128,0,0,0,0,0,
		0,0,0,0,63,240,255,129,248,255,192,0,0,0,0,0,
		0,0,0,0,127,241,247,199,249,255,192,0,0,0,0,0,
		0,0,0,0,113,243,195,207,241,199,192,0,0,0,0,0,
		0,0,0,0,1,247,195,207,240,7,192,0,0,0,0,0,
		0,0,0,0,3,231,135,193,240,15,128,0,0,0,0,0,
		0,0,0,0,7,207,135,129,224,31,0,0,0,0,0,0,
		0,0,0,0,31,143,15,129,224,126,0,0,0,0,0,0,
		0,0,0,0,126,15,15,3,225,248,0,0,0,0,0,0,
		0,0,0,1,248,15,159,3,199,224,0,0,0,0,0,0,
		0,0,0,3,255,143,254,3,207,254,0,0,0,0,0,0,
		0,0,0,3,255,135,252,7,207,254,0,0,0,0,0,0,
		0,0,0,3,255,3,240,7,143,252,0,0,0,0,0,0 };
	const unsigned char intro[] = {
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,0,0,0,0,7,224,3,255,192,0,3,255,255,
		255,255,252,0,0,0,0,3,192,1,255,128,0,1,255,255,
		255,255,248,127,255,255,255,243,207,249,255,159,255,248,255,255,
		255,255,241,255,255,255,255,243,159,252,255,159,255,252,127,255,
		255,255,243,255,255,255,255,243,159,252,255,159,255,254,127,255,
		255,255,227,255,255,255,255,243,159,252,127,159,255,255,63,255,
		255,255,227,252,0,31,192,3,63,62,127,159,192,127,63,255,
		255,255,227,248,0,15,128,7,63,62,127,159,128,63,63,255,
		255,255,227,248,255,207,159,255,62,30,63,159,159,31,63,255,
		255,255,227,248,255,207,159,254,126,31,63,159,159,31,63,255,
		255,255,241,252,127,207,159,254,124,207,63,159,128,63,63,255,
		255,255,248,254,63,207,159,252,124,207,63,159,192,126,63,255,
		255,255,252,126,63,207,159,252,252,207,159,159,255,252,127,255,
		255,255,254,63,31,207,159,252,252,207,159,159,255,248,255,255,
		255,255,254,63,143,207,159,248,252,15,143,159,255,241,255,255,
		255,255,254,63,207,207,159,249,254,31,207,159,159,243,255,255,
		254,0,0,63,199,207,159,249,255,255,199,159,143,240,0,127,
		252,0,0,127,199,207,159,241,255,255,199,159,135,248,0,63,
		252,255,255,255,199,207,159,243,255,255,231,159,131,255,255,63,
		252,255,255,255,207,207,159,243,255,255,231,159,129,255,255,63,
		252,255,255,255,143,207,159,231,224,3,243,159,144,255,255,63,
		252,255,255,255,31,207,159,231,192,1,243,159,152,127,255,63,
		252,255,255,254,31,207,159,231,207,249,243,159,156,63,255,63,
		252,0,0,0,63,192,31,224,15,248,3,128,30,0,0,63,
		254,0,0,0,255,224,63,240,31,252,7,192,63,128,0,127,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,1,240,15,128,254,0,31,252,0,0,63,254,0,0,127,
		254,0,224,7,0,124,0,15,248,0,0,31,254,0,0,63,
		254,124,231,231,62,124,255,207,249,255,255,7,252,255,255,63,
		254,124,207,243,62,124,255,207,249,255,255,199,249,255,255,63,
		254,124,207,243,62,121,255,231,249,255,255,227,249,255,255,63,
		255,62,15,240,124,249,255,231,249,255,255,243,243,255,255,63,
		255,62,31,240,124,249,243,231,249,252,7,243,243,255,255,63,
		255,62,31,248,124,243,243,243,249,248,3,243,243,252,0,63,
		255,159,63,248,249,243,225,243,249,249,241,243,243,248,0,127,
		255,159,63,252,249,243,225,243,249,249,241,243,243,248,255,255,
		255,159,63,252,249,231,237,243,249,248,3,243,241,252,127,255,
		255,207,254,127,241,231,204,249,249,252,7,243,248,254,63,255,
		255,207,254,127,243,207,204,249,249,255,255,227,252,126,63,255,
		255,207,254,127,243,207,204,249,249,255,255,231,254,127,31,255,
		255,231,252,63,227,207,192,252,249,255,255,207,255,63,143,255,
		255,231,252,63,231,159,225,252,249,255,255,159,255,63,207,255,
		255,231,252,63,231,159,255,252,249,252,255,128,0,63,199,255,
		255,243,249,159,199,159,255,254,121,252,127,192,0,127,199,255,
		255,243,249,159,207,63,255,254,121,252,63,255,255,255,199,255,
		255,243,249,159,207,63,255,254,121,252,31,255,255,255,207,255,
		255,249,243,207,159,62,0,63,57,252,143,255,255,255,143,255,
		255,249,243,207,158,124,0,31,57,252,199,255,255,255,15,255,
		255,249,243,207,158,124,255,159,57,252,225,255,255,254,31,255,
		255,248,3,192,30,0,255,128,57,252,240,0,0,0,63,255,
		255,252,7,224,63,1,255,192,120,0,248,0,0,0,127,255,
		255,255,255,255,255,255,255,255,252,1,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 };
	ML_clear_vram();
	ML_bmp_or_cl(intro,0,0,128,64);
	ML_display_vram();
	while(!IsKeyDown(KEY_CTRL_EXE));
	ML_clear_vram();
	ML_bmp_or_cl(louloux,0,12,128,44);
	for(i=29;i<100;++i){
		ML_pixel(i,33,1);
		ML_pixel(i,35,1);   // le sabre s'ouvre de gauche a droite: boucle itrative
		ML_display_vram();
		Sleep(5);
	}
	ML_pixel(100,34,1);
	ML_display_vram();
	while(!IsKeyDown(KEY_CTRL_EXE));
}
// introduction toute bte:
// affichage de l'image star wars, attente d'appui de [EXE]
// affichage de l'image louloux 2012 et dessin du sabre laser, attente d'appui de [EXE]

int dessin(int x, int y){
	int i,j,k;
	const unsigned char fond[976] = { 0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,0,8,0,
		0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,15,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,3,192,0,0,0,0,0,0,
		0,0,0,0,0,0,3,128,0,48,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,
		0,0,0,0,0,0,16,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,128,0,0,0,0,0,
		0,0,0,0,0,0,128,0,0,0,64,0,0,0,0,0,0,0,0,0,0,1,0,0,248,0,32,0,0,0,0,0,
		0,0,0,0,0,2,0,3,6,0,16,0,0,0,0,0,0,0,0,0,0,4,0,4,33,0,8,0,0,0,0,0,
		0,0,0,0,0,8,0,5,37,0,4,0,0,0,0,0,0,0,1,0,0,8,0,8,136,128,4,0,0,0,0,0,
		0,0,0,0,0,16,0,8,80,128,2,0,0,0,0,0,0,0,0,0,0,16,0,11,6,128,2,0,0,0,0,0,
		0,0,0,0,0,32,0,8,80,128,1,0,0,0,0,0,0,0,0,0,0,32,0,8,136,128,1,0,0,0,0,0,
		0,0,0,0,0,64,0,5,37,0,0,128,1,0,0,0,0,0,0,0,0,64,0,4,33,0,0,128,0,0,0,0,
		0,0,0,0,0,64,0,3,6,0,0,128,0,0,0,0,0,0,0,0,0,128,0,0,248,0,0,64,0,0,0,0,
		0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,
		0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,
		0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,
		0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,64,0,0,0,16,
		0,0,0,0,64,64,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,128,0,0,0,0,
		0,0,0,0,0,64,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,32,0,0,0,0,1,0,0,0,0,0,
		2,0,0,0,0,32,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,16,0,0,0,0,2,0,0,0,0,0,
		0,0,0,0,0,16,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,4,0,0,0,0,0,
		0,0,0,0,0,8,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,4,0,0,0,0,8,0,0,0,0,0,
		0,0,0,0,0,2,0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,32,0,0,0,0,0,
		0,0,0,0,0,0,128,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,128,0,0,0,0,128,
		0,0,0,0,0,0,16,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,12,0,0,12,0,0,0,0,0,0,
		0,0,0,0,0,0,3,128,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,112,3,128,0,4,0,0,0,0,
		0,0,0,0,0,0,0,15,252,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
	const unsigned char vaisseau1[90] =
		{ 112,0,0,0,7,0,206,0,
		0,0,57,2,97,192,28,1,195,0,28,56,107,14,28,0,
		3,134,156,176,224,0,0,113,156,199,0,0,0,14,127,56,
		0,0,0,1,255,192,0,0,0,14,127,56,0,0,0,113,
		156,199,0,0,3,134,156,176,224,0,28,56,99,14,28,0,
		97,192,0,1,195,0,206,0,0,0,57,2,112,0,0,0,
		7,0 };
	const unsigned char vaisseau2[90] = 
		{ 255,255,255,255,255,2,207,255,
		255,255,249,2,225,255,255,255,195,2,252,63,235,254,31,2,
		255,135,156,240,255,2,255,241,156,199,255,2,255,254,127,63,
		255,2,255,255,255,255,255,2,255,254,127,63,255,2,255,241,
		156,199,255,2,255,135,156,240,255,2,252,63,255,254,31,2,
		225,255,255,255,195,2,207,255,255,255,249,2,255,255,255,255,
		255,2 };
	ML_clear_vram();
	ML_bmp_or_cl(fond,0,3,128,59); // fond avec l'etoile noire
	for(k=9;k>=0;--k){
		for(j=0;j<2;++j){  // parcours de l'espace en recherche de vaisseaux a dessiner
			for(i=0;i<5;++i){
				if(espace[i][j][k]==1){ // si il y a un vaisseau alors on l'affiche
					char vaisseaunoirx[192] = 
							{ 2,21,1,2,21,22,1,2,21,22,1,2,21,22,
							1,2,21,22,1,2,21,22,1,2,21,22,1,2,
							21,22,1,2,21,22,1,2,10,11,12,13,21,22,
							1,2,8,9,10,11,12,13,14,15,21,22,1,2,7,8,15,
							16,21,22,1,2,7,10,13,16,21,22,1,2,3,6,7,
							9,10,13,14,16,17,20,21,22,1,2,3,4,5,6,7,11,12,
							16,17,18,19,20,21,22,1,2,3,4,5,6,7,11,12,16,17,
							18,19,20,21,22,1,2,3,6,7,9,10,13,14,16,17,20,21,
							22,1,2,7,10,13,16,21,22,1,2,8,15,21,22,
							1,2,9,10,11,12,13,14,21,22,1,2,21,22,1,2,
							21,22,1,2,21,22,1,2,21,22,1,2,21,22,
							1,2,21,22,1,2,21,22,1,2,21,22,1,2,21,
							22,2,21 };
					char vaisseaunoiry[192] =
							{ 0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,
							5,5,5,5,6,6,6,6,7,7,7,7,8,8,8,8,9,
							9,9,9,9,9,9,9,10,10,10,10,10,10,10,10,10,10,10,10,
							11,11,11,11,11,11,11,11,12,12,12,12,12,12,12,
							12,13,13,13,13,13,13,13,13,13,13,13,13,13,13,14,14,
							14,14,14,14,14,14,14,14,14,14,14,14,14,14,15,15,15,
							15,15,15,15,15,15,15,15,15,15,15,15,15,16,16,
							16,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,17,
							17,17,17,18,18,18,18,18,18,19,19,19,19,19,19,19,19,
							19,19,20,20,20,20,21,21,21,21,22,22,22,
							22,23,23,23,23,24,24,24,24,25,25,25,25,
							26,26,26,26,27,27,27,27,28,28,28,
							28,29,29 };
					char vaisseaublancx[44] =
							{ 9,10,11,12,13,14,8,11,12,15,8,11,12,15,8,9,10,13,14,15,
							8,9,10,13,14,15,8,11,12,15,8,11,12,15,9,10,11,12,13,14 };
					char vaisseaublancy[44] =
							{ 11,11,11,11,11,11,12,12,12,12,12,12,13,13,13,13,14,14,
							14,14,14,14,15,15,15,15,15,15,16,16,16,16,17,17,17,17,17,
							17,18,18,18,18,18,18 };
					represent(vaisseaunoirx,vaisseaunoiry,vaisseaublancx,vaisseaublancy,192,44,24*i,30*j,(double)k);
					// appel de la fonction qui represente le vaisseau en perspective
				}
			}
		}
	}
	ML_bmp_or_cl(vaisseau1,4*x,4*y,41,15);
	ML_bmp_and_cl(vaisseau2,4*x,4*y,41,15); // vaisseau devant avec semi-transparence
	ML_display_vram();
}
// la fonction de dessin de tout l'espace appelee a chaque tour

int gameover(int score){
	const unsigned char gameover[] = {
		255,255,255,255,255,255,255,255,255,255,255,255,255,127,255,255,
		255,255,255,255,255,255,255,255,255,127,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,254,255,255,255,251,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,245,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,238,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,223,127,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,191,191,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,127,223,255,255,255,255,255,255,255,
		255,223,255,255,255,255,254,255,239,255,255,255,255,255,255,255,
		255,255,255,255,255,255,253,255,247,247,255,255,255,255,255,255,
		255,255,255,255,255,255,219,255,251,255,255,255,255,255,255,255,
		255,255,255,255,255,255,247,255,253,255,255,255,255,127,255,255,
		255,255,255,255,255,255,239,255,254,255,255,255,255,255,255,255,
		255,255,255,255,255,255,223,255,255,127,255,255,255,255,255,255,
		255,255,255,252,0,0,63,255,255,128,0,15,255,255,255,255,
		255,255,255,251,255,255,255,255,255,255,255,247,255,255,255,255,
		255,255,255,253,255,255,255,255,255,255,255,239,255,255,255,255,
		255,255,0,0,255,255,255,255,255,255,255,224,0,127,255,255,
		255,254,255,255,255,255,255,255,255,255,255,255,255,191,255,255,
		255,255,127,255,255,255,255,255,255,255,255,255,255,127,255,255,
		255,255,191,255,255,255,255,255,255,255,255,255,252,255,255,255,
		255,255,223,255,255,255,255,255,255,255,255,255,249,255,255,255,
		255,255,231,255,255,255,255,255,255,255,255,255,247,255,255,255,
		255,255,251,255,255,255,255,255,255,255,255,255,239,255,255,255,
		255,255,252,255,255,255,255,255,255,255,251,255,159,255,253,255,
		255,255,255,127,225,198,232,120,221,8,123,255,127,255,255,255,
		255,255,255,191,222,186,75,247,93,123,187,254,255,255,255,255,
		255,255,255,207,223,186,171,247,93,123,187,249,255,255,255,255,
		255,255,255,243,223,186,232,247,93,24,123,247,255,255,255,255,
		255,255,255,253,220,130,235,247,93,122,251,239,255,255,255,255,
		223,255,251,243,222,186,235,247,107,123,127,247,255,255,255,255,
		255,255,255,239,225,186,232,120,247,11,187,251,255,255,255,255,
		255,255,255,223,255,255,255,255,255,255,255,252,255,255,255,255,
		255,255,255,63,255,255,255,255,255,255,255,255,127,255,255,255,
		255,255,254,255,255,255,255,255,255,255,255,255,191,255,255,255,
		255,255,249,255,255,255,255,255,255,255,255,255,207,127,255,255,
		255,255,247,255,255,255,255,255,255,255,255,255,247,255,255,255,
		255,255,239,255,255,255,255,255,255,255,255,255,251,255,255,255,
		255,255,159,255,255,255,255,255,255,255,255,255,252,255,255,255,
		255,255,127,255,255,255,255,255,255,255,255,255,255,127,255,255,
		255,255,128,1,255,255,255,255,255,255,255,224,0,63,255,255,
		255,255,255,251,255,255,255,255,255,255,255,247,255,255,255,255,
		255,255,255,240,0,0,63,255,255,0,0,3,255,255,255,255,
		255,255,255,255,255,255,223,255,254,255,255,255,255,255,255,255,
		255,255,255,255,255,255,239,255,253,255,255,255,255,255,255,255,
		255,247,255,255,255,255,247,255,251,255,255,255,255,255,255,255,
		255,255,255,255,255,255,251,255,247,255,127,255,255,255,255,255,
		255,255,255,255,255,255,253,255,239,255,255,255,255,255,255,255,
		255,255,255,255,255,255,254,255,223,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,127,191,255,255,255,255,255,255,255,
		255,255,255,255,255,239,255,191,127,255,255,255,255,255,223,255,
		255,255,255,255,255,255,255,222,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,237,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,243,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,253,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
		255,255,255,255,255,255,255,255,191,255,255,255,223,255,255,255 };
	ML_clear_vram();
	ML_bmp_or_cl(gameover,0,0,128,64); // affichage de l'image de game over
	ML_display_vram();
	while(IsKeyDown(KEY_CTRL_EXE)==0);
	ML_clear_vram();
	locate(1,1);
	Print("Votre score:"); // affichage du score
	printn(13,1,score,0);
	locate(1,3);
	Print("[EXIT]: quitter");
	locate(1,4);
	Print("[SHIFT]: rejouer");
	ML_display_vram();
	while(1){
		if(IsKeyDown(KEY_CTRL_EXIT)==1) return 1;
		else if(IsKeyDown(KEY_CTRL_SHIFT)==1) return 0; // petit menu qui permet au joueur de retenter ou d'arreter
	}
}

int jeu(){
	char x=11, y=6, i, j, k, vie, n=1;
	int score=0;
	for(i=0; i<5; ++i){
		for(j=0; j<2; ++j){
			for(k=0; k<10;++k){
				espace[i][j][k]=0; // initialisation d'un tableau trois dimensions representant l'espace
			}
		}
	}
	do {
		score++; // le score augmente a chaque fois que le vaisseau avance
		dessin(x,y); // appel de la fonction de dessin
		Sleep(75); // ralentisseur parce que le jeu est trop rapide pour etre jouable
		if(IsKeyDown(KEY_CTRL_LEFT)==1 && x>1) x-=2;
		if(IsKeyDown(KEY_CTRL_RIGHT)==1 && x<21) x+=2;
		if(IsKeyDown(KEY_CTRL_UP)==1 && y>0) y-=2;
		if(IsKeyDown(KEY_CTRL_DOWN)==1 && y<12) y+=2; // si le joueur bouge son vaisseau
			for(k=0;k<9;++k){
				for(j=0;j<2;++j){
					for(i=0;i<5;++i){
						espace[i][j][k]=espace[i][j][k+1];
						// avancee des vaisseaux
						// le tableau se decale
					}
				}
			}
			for(j=0;j<2;++j){
				for(i=0;i<5;++i){
					espace[i][j][9]=0; // initialisation de la derniere profondeur
				}
			}
			if(n==0) espace[rand()%5][rand()%2][9]=1; // tirage aleatoire d'une position pour un chasseur Tie une fois sur cinq
			n=(n+1)%6;
			vie=1;
			for(j=0;j<2;++j){
				for(i=0;i<5;++i){
					if(espace[i][j][0]==1) if(4*x+41>24*i && 4*x<24*(i+1) && 4*y+15>30*j && 4*y<30*(j+1)) vie=0; // verifie s'il n'y a pas de collision
				}
			}
	} while(IsKeyDown(KEY_CTRL_EXIT)==0 && vie==1);
	if(IsKeyDown(KEY_CTRL_EXIT)==0) return gameover(score); // si collision gameover
	// si exit on sort sans passer par game over
	return 1;
}
// fonction de jeu, qui tourne en permanence:
// fait avancer les vaisseaux enememis
// attend les entrees du joueur

int AddIn_main(int isAppli, unsigned short OptionNum){
	int R=0;
	intro();
	do{
		R=jeu();
		if(R==1) return 0;
	} while(R==0);
}
// principale qui tourne tant qu'on fait rejouer et si on fait exit sort


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

int InitializeSystem(int isAppli, unsigned short OptionNum)
{
return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
// et on quitte le programme sans reboot

#pragma section